import greenfoot.*;
import java.util.List;
public class Ball  extends Speed
{
    public boolean Fixed=false;
    private Platform PF;
    private int StartSpeed;
    private int PosToPF=0;

    public void act()
    {
        if(!Fixed)
        {
            while(Pos(getSpeedX())+Pos(getSpeedY())<getMaxSpeed()-0.09)
            {
                if(getSpeedY()<0)
                    setSpeedY(getSpeedY()-0.1);
                if(getSpeedY()>0)
                    setSpeedY(getSpeedY()+0.1);
            }
            if(Pos(getSpeedY())<10)
            {
                if(getSpeedX()<0)
                {
                    setSpeedX(-90);
                    setSpeedY(-10);
                }
                else
                if(getSpeedX()>0)
                {   
                    setSpeedX(90);
                    setSpeedY(-10);
                }
                else
                {
                    setSpeedX(45);
                    setSpeedY(-45);
                }
            }
            move();
            CheckPosition();
        }
        else
            beFixed();
    }

    public void Fix(Platform PF)
    {
        if(getSpeedX()!=0)
        {
            if(getSpeedX()>0)
            {
                StartSpeed=1;
            }
            if(getSpeedX()<0)
            {
                StartSpeed=-1;
            }
        }
        else
        {
            if(Greenfoot.getRandomNumber(2)==1)
            {
                StartSpeed=1;
            }
            else
            {
                StartSpeed=-1;
            }
        }
        Fixed=true;
        this.PF=PF;
        PosToPF = getX()-PF.getX();
        beFixed();
    }

    private void beFixed()
    {
        setLocation(PF.getX()+PosToPF,PF.getY()-(PF.getImage().getHeight()/2+getImage().getHeight()/2));
    }

    public void Start()
    {
        setSpeed(50*StartSpeed,-50);
        Fixed=false;
        PF.Fix=false;
    }

    public void CheckPosition()
    {
        if(getX()==0)
        {removeObject();}
        else
        if(getX()==getWorld().getWidth()-1)
        {removeObject();}
        else
        if(getY()==getWorld().getHeight()-1)
        {removeObject();}
        else
        if(getY()==0)
        {removeObject();}
    }

    public void removeObject()
    {
        getWorld().removeObject(this);
    }

    public void CheckHit()
    {
        Platform PF = (Platform) getOneIntersectingObject(Platform.class);
        if(PF!=null)
        {
            if(PF.Fix)
            {
                Fix(PF);
                PF.BallBoing();
            }
            else
                PF.Spoing(this);
        }

        List<Barrier> B = (List<Barrier>) getIntersectingObjects(Barrier.class);    
        for(Barrier Bar : B)
        {
            Bar.Spoing(this);
        }
    }
}
