import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.util.List;
/**
 * Write a description of class Platform here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Platform  extends Barrier
{
    private int x=500;
    private int XSide;
    public boolean Fix=false;
    public boolean Magnet=true;
    public boolean NewBalls=true;
    public boolean BigBalls=false;
    public boolean BigPlatform=false;
    public boolean Beam=false;
    public Ball Ball;
    public int []Time = new int[100];

    public Platform()
    {
        GreenfootImage i = new GreenfootImage (100,25);
        i.setColor(Color.red);
        i.fillRect(0,0,100,25);
        setImage(i);
    }

    public Platform(GreenfootImage i)
    {
        setImage(i);
    }

    public void act()
    {
        Extras();
        setMaxSpeed(200);
        MouseSearching();
        Fix();
    }

    public void Fix()
    {
        if(Greenfoot.mouseClicked(null))
        {
            if(Beam)
                if(!AnyBallFixed())
                {
                    Beam();
                    Beam=false;
            }
            if(Fix)
            {
                List<Ball> Balls = getWorld().getObjects(Ball.class);
                for(Ball B : Balls)
                {
                    if(B.Fixed)
                        B.Start();
                }
            }
        }
    }

    public boolean AnyBallFixed()
    {
        List<Ball> Balls = getWorld().getObjects(Ball.class);
        for(Ball B : Balls)
        {
            if(B.Fixed)
                return true;
        }
        return false;
    }

    public void Beam()
    {
        GreenfootImage b = new GreenfootImage("Beam.PNG");
        GreenfootImage i = new GreenfootImage(50,getWorld().getHeight()-(getWorld().getHeight()-getY()+getImage().getHeight()/2));
        for(int a=0; a<i.getHeight();a++)
        {
            i.drawImage(b,0,a);
        }
        getWorld().addObject(new Beam(i),getX(),i.getHeight()/2);
    }

    public void BigBalls()
    {
        BigBalls=true;
        List<Ball> Balls=getWorld().getObjects(Ball.class);
        for(Ball B : Balls)
        {
            B.setImage("button-blue.png");
        }
    }

    public void Extras()
    {
        ExtrasEffects();
        SearchForExtras();
    }

    public void SearchForExtras()
    {
        Extra Extra = (Extra) getOneIntersectingObject(Extra.class);
        if(Extra!=null)
        {
            Extra.SpecialEffect(this);
            getWorld().removeObject(Extra);
        }
    }

    public void Grow()
    {
        int x = getImage().getWidth()+50;
        if(x>getWorld().getWidth()-150)
        {
            x=getWorld().getWidth()-150;
        }
        GreenfootImage i = new GreenfootImage(x,25);
        i.setColor(new Color(0,100,0));
        i.fill();
        setImage(i);
        BigPlatform=true;
        Time[3]+=1500;
        if(getX()<getWorld().getWidth()/2)
            setLocation(getX()+25,getY());
        else
            setLocation(getX()-25,getY());
    }

    public void ExtrasEffects()
    {
        if(Magnet)
        {
            Fix=true;
            getImage().setColor(new Color(50,50,50));
            getImage().fill();
        }

        if(Time[0]<=0)
        {
            Time[0]=0;
            Magnet=false;
            if(BigPlatform)
                getImage().setColor(new Color(0,100,0));
            else
                getImage().setColor(Color.red);
            getImage().fill();
        }

        CheckBalls();

        if(NewBalls)
        {
            addNewBall();
        }

        if(BigPlatform)
        {
            Time[3]--;
        }

        if(BigBalls)
        {
            Time[2]++;
        }

        if(Beam)
        {
            GreenfootImage b = new GreenfootImage("Beam.PNG");
            for(int a=0; a<getImage().getHeight();a++)
                getImage().drawImage(b,getImage().getWidth()/2-b.getWidth()/2,a);
        }
        if(Time[2]>=1000)
        {
            List<Ball> Balls = getWorld().getObjects(Ball.class);
            for(Ball B : Balls)
            {
                B.setImage("ball.png");
            }
            Time[2]=0;
            BigBalls=false;
        }

        if(Time[1]<=0)
        {
            Time[1]=0;
            NewBalls=false;
        }

        if(Time[3]<0)
        {
            Time[3]=0;
            BigPlatform=false;
            GreenfootImage i = new GreenfootImage (100,25);
            i.setColor(Color.red);
            i.fillRect(0,0,100,25);
            setImage(i);
        }
    }

    public void addNewBall()
    {
        if(!Ball.Fixed)
        {
            Ball B = new Ball();
            getWorld().addObject(B,getX(),350);
            B.Fix(this);
            Ball=B;
            Fix=true;
            Time[1]--;
        }
    }

    public void CheckBalls()
    {
        int b=0;
        List<Ball> Balls = getWorld().getObjects(Ball.class);
        for(Ball B : Balls)
        {
            b++;
        }
        if(b==0)
        {
            Ball B = new Ball();
            getWorld().addObject(B,getX(),350);
            B.Fix(this);
            Ball=B;
            Fix=true;
            ((Welt)getWorld()).getLives(-1);
            //for(int i=0; i<Time.length;i++)
            //Time[i]=0;
        }
    }

    public void MouseSearching()
    {
        MoveToMouse();
        SearchForMouse();
    }

    public void MoveToMouse()
    {
        DontMoveOverX();
        if(XSide==0)
            return;
        if(getX()-getSpeedX()/(getMaxSpeed()/10)>x)
            if(getX()+getSpeedX()/(getMaxSpeed()/10)>x)
                setSpeedX(getSpeedX()-20);
            else
            {
                setLocation(x,getY());
                setSpeedX(0);
                XSide=0;
        }
        if(getX()-getSpeedX()/(getMaxSpeed()/10)<x)
            if(getX()+getSpeedX()/(getMaxSpeed()/10)<x)
                setSpeedX(getSpeedX()+20);
            else
            {
                setLocation(x,getY());
                setSpeedX(0);
                XSide=0;
        }
        move();
        if(getSpeedX()==0)
            return;
        if(getOneIntersectingObject(Barrier.class)!=null)
        {
            while(getOneIntersectingObject(Barrier.class)!=null)
            {
                if(getSpeedX()>0)
                {
                    setLocation(getX()-1,getY());
                    x=getX();
                }
                else
                if(getSpeedX()<0)
                {
                    setLocation(getX()+1,getY());
                    x=getX();
                }
            }
            setSpeedX(0);
            XSide=0;
        }
    }

    public void DontMoveOverX()
    {
        if(XSide==1)
        {
            if(x<getX())
            {
                setLocation(x,getY());
                setSpeedX(0);
                XSide=0;
            }
        }

        if(XSide==-1)
        {
            if(x>getX())
            {
                setLocation(x,getY());
                setSpeedX(0);
                XSide=0;
            }
        }
    }

    public void FixBall()
    {
        Fix=true;
    }

    public void BallBoing()
    {
        if(Magnet)
        {
            Time[0]--;
        }
    }

    public void SearchForMouse()
    {
        if(Greenfoot.mouseMoved(null))
        {
            x=Greenfoot.getMouseInfo().getX();
            if(x>getX())
                XSide=1;
            else
            if(x<getX())
                XSide=-1;
            else
                XSide=0;
        }
    }
}
