import greenfoot.*;
/**
 * Die Klasse Speed hat einige ntzliche Funktionen.
 * man kann zudem die Unterklassen der Klasse Speed, sich mit x und y Geschwindigkeiten Bewegen lassen.
 * 
 * Moritz Lintner 
 * 08.06.2011
 */
public class Speed extends Actor
{
    private double LocationX;
    private double LocationY;
    private double SpeedX=0;
    private double SpeedY=0;
    private double MaxSpeed=100;

    public void act() 
    {
        move();
    }

    /** Das Objekt bewegt sich mit seiner Geschwindigkeit*/
    public void move()
    {
        for(int a=0;a<MaxSpeed/10;a++)
        {
            CheckSpeed();
            LocationX+=SpeedX/MaxSpeed;
            LocationY+=SpeedY/MaxSpeed;
            setLocation(LocationX,LocationY);
            CheckHit();
        }
    }

    public double Pos(double a)
    {
        if(a<0)
            a=-a;
        return a;
    }

    private void CheckSpeed()
    {
        while(Pos(SpeedX)+Pos(SpeedY)>MaxSpeed)
        {
            if(SpeedX>0)
                SpeedX-=0.1;
            if(SpeedX<0)
                SpeedX+=0.1;
            if(SpeedY>0)
                SpeedY-=0.1;
            if(SpeedY<0)
                SpeedY+=0.1;
        }
    }

    public void CheckHit()
    {
    }

    public void setLocation(int x, int y)
    {
        setLocation((double)x,(double)y);
    }

    public void setLocation(double x, double y)
    {
        InitializeLocation(x,y);
        super.setLocation((int)x,(int)y);
    }

    /** Initialisiert die neue Position */
    public void InitializeLocation(double x, double y)
    {
        LocationX=x;
        LocationY=y;
    }

    /** setzt die Geschwindigkeit in x und y Richtung */
    public void setSpeed(double x, double y)
    {
        setSpeedX(x);
        setSpeedY(y);
    }

    /** setzt die Geschwindigkeit in x Richtung */
    public void setSpeedX(double x)
    {
        SpeedX=x;
    }
    
    /** setzt die maximale Geschwindigkeit */
    public void setMaxSpeed(double MaxSpeed)
    {
        this.MaxSpeed=MaxSpeed;
    }
    
    /** setzt die Geschwindigkeit in y Richtung */
    public void setSpeedY(double y)
    {
        SpeedY=y;
    }

    /** gibt die Geschwindigkeit in x Richtung zurck */
    public double getSpeedX()
    {
        return SpeedX;
    }

    /** gibt die Geschwindigkeit in y Richtung zurck */
    public double getSpeedY()
    {
        return SpeedY;
    }
    
    /** gibt die maximale Geschwindigkeit zurck */
    public double getMaxSpeed()
    {
        return MaxSpeed;
    }
    
    public int Random(int a)
    {return Greenfoot.getRandomNumber(a);}
}
