import greenfoot.*;
import greenfoot.core.WorldHandler;
import javax.swing.*;
import java.awt.Cursor;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.Color;
import java.awt.Graphics;
import java.util.List;

public class Welt  extends World
{
    Counter Score = new Counter("Score: ", Color.green);
    Counter Lives = new Counter("Lives: ", Color.red);
    int [][][]Levels={
            {
                {},
                {},
                { 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0},
                { 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0},
                { 0, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1, 0},
                { 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0},
                { 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0},
            },

            {
                {},
                {},
                { 0, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 0},
                { 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0},
                {},
                {},
                { 0, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 0},
                { 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0},
            },

            {
                {},
                {},
                { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                { 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1},
                { 1, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 1},
                {},
                {},
                {-1,-1,-1,-1,-1,-1,-1, 0, 0, 0, 0,-1,-1,-1,-1,-1,-1,-1},
                { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                { 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2},
                { 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2},
                { 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2},
            },
            {
                {},
                {},
                {},
                { 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0},
                { 0, 0, 0, 0, 0, 0, 0, 1, 2, 2, 1, 0, 0, 0, 0, 0, 0, 0},
                { 0, 0, 0, 0, 0, 0, 1, 2, 3, 3, 2, 1, 0, 0, 0, 0, 0, 0},
                { 0, 0, 0, 0, 0, 1, 2, 3, 4, 4, 3, 2, 1, 0, 0, 0, 0, 0},
                { 0, 0, 0, 0, 1, 2, 3, 4, 5, 5, 4, 3, 2, 1, 0, 0, 0, 0},
                { 0, 0, 0, 1, 2, 3, 4, 5, 6, 6, 5, 4, 3, 2, 1, 0, 0, 0},
                { 0, 0, 0, 1, 2, 3, 4, 5, 6, 6, 5, 4, 3, 2, 1, 0, 0, 0},
                { 0, 0, 0, 0, 1, 2, 3, 4, 5, 5, 4, 3, 2, 1, 0, 0, 0, 0},
                { 0, 0, 0, 0, 0, 1, 2, 3, 4, 4, 3, 2, 1, 0, 0, 0, 0, 0},
                { 0, 0, 0, 0, 0, 0, 1, 2, 3, 3, 2, 1, 0, 0, 0, 0, 0, 0},
                { 0, 0, 0, 0, 0, 0, 0, 1, 2, 2, 1, 0, 0, 0, 0, 0, 0, 0},
                { 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0},
            },

            {
                { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                { 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2},
                { 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3},
                { 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4},
                { 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5},
                { 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4},
                { 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3},
                { 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2},
                { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                {},
                { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                { 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2},
                { 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3},
                { 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2},
                { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                {},
                {},
                { 8, 8, 8, 8, 8, 8, 8, 8, 0, 0, 8, 8, 8, 8, 8, 8, 8, 8},
                { 8, 8, 8, 8, 8, 8, 8, 8, 0, 0, 8, 8, 8, 8, 8, 8, 8, 8},
                { 8, 8, 8, 8, 8, 8, 8, 8, 0, 0, 8, 8, 8, 8, 8, 8, 8, 8}
            }

        };
    int Level=0;

    public Welt()
    {
        super(1000,700,1);
        Greenfoot.setSpeed(50);
        Level(Level);
        WallAround();
        addObject(new Platform(),getWidth()/2,getHeight()-25);
        addObject(Score,getWidth()/2,25);
        addObject(Lives,100,25);
        Lives.add(11);
        Greenfoot.start();
        setPaintOrder(Counter.class,Actor.class);
    }

    public void act()
    {
        ChangeMouseImage(new GreenfootImage(1,1),1,1);
        if(NoBricks())
        {NextLevel();}
        if(Lives.getTarget()<=0)
        {
            GameLost();
        }
    }

    public void GameLost()
    {
        while(Lives.getTarget()<10)
            Lives.add(1);
        while(Score.getTarget()>0)
            Score.add(-100);
        while(Score.getTarget()<0)
            Score.add(1);
        Level=-1;
        NextLevel();
    }

    public boolean NoBricks()
    {
        return !AnyBrick();
    }

    public boolean AnyBrick()
    {
        List<Brick> B = getObjects(Brick.class);
        for(Brick b : B)
            return true;
        return false;
    }

    public void NextLevel()
    {
        Level++;
        List<Ball> B = getObjects(Ball.class);
        for(Ball b:B)
        {
            Score.add(10);
            removeObject(b);    
        }
        removeObjects(getObjects(Barrier.class));
        WallAround();
        addObject(new Platform(),getWidth()/2,getHeight()-25);
        Level(Level);
        Lives.add(2);
    }

    public void Level(int Level)
    {
        if(Level>=Levels.length)
            Level=Levels.length-1;
        if(Level<0)
            Level=0;
        Bricks(Levels[Level]);
    }

    public void Bricks(int [][]a)
    {
        for(int y=0; y<a.length;y++)
            for(int x=0; x<a[y].length;x++)
            {
                int z = a[y][x];
                if(z<0)
                {
                    BlackBrick(x+1,y+1);
                }
                else
                if(z>0)
                    addObject(new Brick(z),x+1,y+1);
        }
    }

    public void BlackBrick(int x, int y)
    {
        Barrier(x,y);
    }

    public void Barrier(int x,int y)
    {
        GreenfootImage i = new GreenfootImage(50,25);
        i.fill();
        addObject(new Barrier(i),25+x*50,61-25+y*25);
    }

    private void addObject(Brick B, int x, int y)
    {
        super.addObject(B,25+x*50,61-25+y*25);
    }

    private void WallAround()
    {
        GreenfootImage i = new GreenfootImage(50,getHeight());
        i.setColor(Color.black);
        i.fillRect(0,0,50,getHeight());
        addObject(new Barrier(i),25,getHeight()/2);
        i = new GreenfootImage(getWidth(),50);
        i.setColor(Color.black);
        i.fillRect(0,0,getWidth(),55);
        addObject(new Barrier(i),getWidth()/2,25);
        i = new GreenfootImage(50,getHeight());
        i.setColor(Color.black);
        i.fillRect(0,0,50,getHeight());
        addObject(new Barrier(i),getWidth()-25,getHeight()/2);
    }

    public void ChangeMouseImage(GreenfootImage image, int XClick, int YClick)
    {
        JPanel Panel = WorldHandler.getInstance().getWorldCanvas();
        Cursor Cursor;
        Toolkit Tk = Toolkit.getDefaultToolkit();
        Point CursorPoint= new Point(XClick,YClick);
        Cursor = Tk.createCustomCursor(image.getAwtImage(),CursorPoint,"Somehow");
        Panel.setCursor(Cursor);
    }

    public void addObject(Speed S, int x, int y)
    {
        super.addObject(S,x,y);
        S.InitializeLocation(x,y);
    }

    public void getPoints(int HowMany)
    {
        Score.add(HowMany);
    }

    public void getLives(int HowMany)
    {
        Lives.add(HowMany);
    }
}
